//
// RCMReboot - hippy dave
//

#include "cross2d/c2d.h"
#include <time.h>

#define XSIZE 500
#define YSIZE 100
#define COUNTDOWNTIME 5

using namespace c2d;

int main(int argc, char **argv) {

	unsigned int keys;
	int countdown;
	time_t timer, timer2;
	char cd [2];
#if defined(__SWITCH__)
	touchPosition touch;
#endif

    // create the main renderer
    auto *renderer = new C2DRenderer({C2D_SCREEN_WIDTH, C2D_SCREEN_HEIGHT});

    // create a rectangle
	C2DRectangle *rect = new C2DRectangle({XSIZE, YSIZE});
	rect->setFillColor(Color::Gray);
	rect->setOrigin(Origin::TopLeft);
	rect->setPosition(renderer->getSize().x / 2 - XSIZE / 2, renderer->getSize().y / 2);
	renderer->add(rect);

	// create text and add it to the renderer
	auto *text = new C2DText("Touch here or press B to cancel");
	text->setOrigin(Origin::Center);
	text->setPosition(renderer->getSize().x / 2, renderer->getSize().y / 2 + YSIZE / 2);
	text->setOutlineThickness(1);
	renderer->add(text);

	auto *textCountdown = new C2DText("Seconds", 200);
	textCountdown->setOrigin(Origin::Center);
	textCountdown->setPosition(renderer->getSize().x / 2, renderer->getSize().y / 2 - YSIZE * 1.5);
	textCountdown->setOutlineThickness(1);
	renderer->add(textCountdown);
	
	auto *textInfo = new C2DText("Rebooting to RCM in");
	textInfo->setOrigin(Origin::Center);
	textInfo->setPosition(renderer->getSize().x / 2, renderer->getSize().y / 2 - YSIZE * 3);
	textInfo->setOutlineThickness(1);
	renderer->add(textInfo);

	countdown = COUNTDOWNTIME;
	time(&timer2);
    // main loop
    while (true) {

        // get player 1 keys state
        keys = renderer->getInput()->getKeys();
        if (keys) {
            // "special" close/quit event send by sdl2 windows (linux platform)
            if (keys & EV_QUIT) {
                break;
            }

			if (keys & Input::Key::KEY_FIRE2) {
				break;
            }//if B
        }//if (keys)

#if defined(__SWITCH__)
		if (hidTouchCount () == 1) {
			hidTouchRead (&touch, 0);
			if ((touch.px > renderer->getSize().x / 2 - XSIZE / 2) && (touch.px < renderer->getSize().x / 2 + XSIZE / 2) && (touch.py > renderer->getSize().y / 2 - YSIZE / 2) && (touch.py < renderer->getSize().y / 2 + YSIZE / 2)) {
				break;
			}//if touched rect
		}//if (hidTouchCount () == 1)
#endif
		
			time(&timer);
			countdown = COUNTDOWNTIME - (int) (timer - timer2);
		if (countdown > -1) {
			snprintf(cd, 2, "%d", countdown);
			textCountdown->setString(cd);
		} else {
#if defined(__SWITCH__)
			Result rc = splInitialize();
			if (R_FAILED(rc)) {
				text->setString("splInitialize failed!");
			} else {
				rc = splSetConfig ((SplConfigItem) 65001, 1);
				if (R_FAILED(rc)) {
					text->setString("splSetConfig failed!");
				}
			}
#endif
		}

        // draw everything
        renderer->flip();
    }

    // cleanup
    // will delete child's (textures, shapes, text..)
    delete (renderer);

    return 0;
}
