// RCMRebootInstant - hippy dave
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// Include the main libnx system header, for Switch development
#include <switch.h>

// Main program entrypoint
int main(int argc, char* argv[])
{
    consoleInit(NULL);

	Result rc = splInitialize();
	if (R_FAILED(rc)) {
		printf("splInitialize failed!\nPress + to exit.\n");
	} else {
		rc = splSetConfig ((SplConfigItem) 65001, 1);
		if (R_FAILED(rc)) {
			printf("splInitialize failed!\nPress + to exit.\n");
		}
	}

    // Main loop
    while (appletMainLoop())
    {
        // Scan all the inputs. This should be done once for each frame
        hidScanInput();

        // hidKeysDown returns information about which buttons have been
        // just pressed in this frame compared to the previous one
        u64 kDown = hidKeysDown(CONTROLLER_P1_AUTO);

        if (kDown & KEY_PLUS)
            break; // break in order to return to hbmenu


        // Update the console, sending a new frame to the display
        consoleUpdate(NULL);
    }

    // Deinitialize and clean up resources used by the console (important!)
    consoleExit(NULL);
    return 0;
}
